//
//  VCSPresentViewController.swift
//  ViewControllerSikenjo
//
//  Created by narita on 2018/12/09.
//  Copyright © 2018 narita. All rights reserved.
//

import Cocoa

class VCSPresentViewController: NSViewController
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods

    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    // MARK: - action methods
    
    @IBAction func showInspectorPanel(_ sender: Any?)
    {
        let theWindowController: NSWindowController
        theWindowController = NSStoryboard(name: "VCSInspectorViewController")
            .instantiateWindowController(withIdentifier: "modeless")
        
        theWindowController.contentViewController?.representedObject = self

        theWindowController.showWindow(nil)
    }
    
    @IBAction func showSheet(_ sender: Any?)
    {
        let theViewController: NSViewController
        theViewController = NSStoryboard(name: "VCSInspectorViewController")
            .instantiateViewController(withIdentifier: "modal")
        
        // ここで引き渡すデータを与える。選択された行の値を入れる。
        theViewController.representedObject = self.arrayController!.selectedObjects!.first
        
        //  sheetがクローズする時に、dissmissが呼ばれる。
        self.presentAsSheet(theViewController)
    }
    
    @IBAction func showDialog(_ sender: Any?)
    {
        let theViewController: NSViewController
        theViewController = NSStoryboard(name: "VCSInspectorViewController")
            .instantiateViewController(withIdentifier: "modal")

        // ここで引き渡すデータを与える。選択された行の値を入れる。
        theViewController.representedObject = self.arrayController!.selectedObjects!.first

        //  dialogがクローズする時に、dissmissが呼ばれる。
        self.presentAsModalWindow(theViewController)
    }
    
    @IBAction func showPopover(_ sender: Any?)
    {
        let theViewController: NSViewController
        theViewController = NSStoryboard(name: "VCSInspectorViewController")
            .instantiateViewController(withIdentifier: "modal")

        // ここで引き渡すデータを与える。選択された行の値を入れる。
        theViewController.representedObject = self.arrayController!.selectedObjects!.first

        self.present(theViewController,
                         asPopoverRelativeTo: tableView!.rect(ofRow: tableView!.selectedRow),
                                          of: tableView!,
                               preferredEdge: NSRectEdge.minY,
                                    behavior: .applicationDefined)
    }


    override func dismiss(_ viewController: NSViewController)
    {
        if let theModalViewController = viewController as? VCSModalViewController
        {
            if theModalViewController.cancelOrOK == true
            {
                let theDict = theModalViewController.representedObject as Any
                
                    // KVOするarrayに変換してObjectをreplaceする。
                self.model_kvo_proxy.replaceObject(at: self.arrayController!.selectionIndex,
                                                   with: theDict)
            }
        }
        
        super.dismiss(viewController)
    }

    
    
    // MARK: - event handling methods

    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    override var representedObject: Any?
    {
        didSet
        {
            // Update the view, if already loaded.
        }
    }
    
    // モデルデータをて適当に作る
    @objc var model: NSMutableArray =
    {
        var theResult = NSMutableArray()
        
        theResult.add(NSMutableDictionary(dictionary: ["title" : "クラゲ", "memo"  : "嫌い。ぼぶよぶよしている。"]))
        theResult.add(NSMutableDictionary(dictionary: ["title" : "クジラ", "memo"  : "缶詰で食べた。うまい。食べられるために生まれた生き物。"]))
        theResult.add(NSMutableDictionary(dictionary: ["title" : "タコ",   "memo"  : "好き。しかしコレステロールの塊らしいので、食べないようにしている。"]))
        theResult.add(NSMutableDictionary(dictionary: ["title" : "イルカ", "memo"  : "小さいクジラ。うまいらしい。"]))
        theResult.add(NSMutableDictionary(dictionary: ["title" : "イカ",   "memo"  : "イカソーメンで食べるのが大好き。が、最近だべてない。"]))
        theResult.add(NSMutableDictionary(dictionary: ["title" : "うに",   "memo"  : "うまいうにを食った事ない。雑巾の香りがする。"]))
        theResult.add(NSMutableDictionary(dictionary: ["title" : "カニ",   "memo"  : "生きているカニかまぼこ。値段が高いが、カニカマに味で負けている"]))
        theResult.add(NSMutableDictionary(dictionary: ["title" : "うなぎ",  "memo"  : "アナゴの方が好み。"]))
        theResult.add(NSMutableDictionary(dictionary: ["title" : "津軽漬け",    "memo"  : "うまい。白米に合う。"]))
        theResult.add(NSMutableDictionary(dictionary: ["title" : "身欠きニシン", "memo"  : "小骨ばかりでうまくない、懐かしいので食べる。"]))

        return theResult
        
        // 以下のようだとimmutableになってしまったので、上記のように変更した
//        return [ ["title" : "クラゲ", "memo"  : "嫌い。ぼぶよぶよしている。"],
//        ["title" : "クジラ", "memo"  : "缶詰で食べた。うまい。食べられるために生まれた生き物。"],
//        ["title" : "タコ",   "memo"  : "好き。しかしコレステロールの塊らしいので、食べないようにしている。"],
//        ["title" : "イルカ", "memo"  : "小さいクジラ。うまいらしい。"],
//        ["title" : "イカ",   "memo"  : "イカソーメンで食べるのが大好き。が、最近だべてない。"],
//        ["title" : "うに",   "memo"  : "うまいうにを食った事ない。雑巾の香りがする。"],
//        ["title" : "カニ",   "memo"  : "生きているカニかまぼこ。値段が高いが、カニカマに味で負けている"],
//        ["title" : "うなぎ",  "memo"  : "アナゴの方が好み。"],
//        ["title" : "津軽漬け",    "memo"  : "うまい。白米に合う。"],
//        ["title" : "身欠きニシン", "memo"  : "小骨ばかりでうまくない、懐かしいので食べる。"]]

    }()
    
    @objc var model_kvo_proxy: NSMutableArray
    {
        return self.mutableArrayValue(forKeyPath: "model")
    }
    
    @IBOutlet var arrayController: NSArrayController? = nil

    @IBOutlet var tableView: NSTableView? = nil
    
    // MARK: - Utility methods
}
